# coding: utf-8

"""
    Prevision.io

    Prevision.io Studio APIs  # noqa: E501

    OpenAPI spec version: 1.0.5
    Contact: web@prevision.io
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class ExportersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def exportersexporter_id_delete(self, , **kwargs):  # noqa: E501
        """delete exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_delete(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.exportersexporter_id_delete_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.exportersexporter_id_delete_with_http_info(, **kwargs)  # noqa: E501
            return data

    def exportersexporter_id_delete_with_http_info(self, , **kwargs):  # noqa: E501
        """delete exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_delete_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method exportersexporter_id_delete" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `exportersexporter_id_delete`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['exporterId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/exporters/:exporterId', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def exportersexporter_id_exports_get(self, , **kwargs):  # noqa: E501
        """get exports from exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_exports_get(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :param  :
        :param  :
        :param  :
        :param  :
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.exportersexporter_id_exports_get_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.exportersexporter_id_exports_get_with_http_info(, **kwargs)  # noqa: E501
            return data

    def exportersexporter_id_exports_get_with_http_info(self, , **kwargs):  # noqa: E501
        """get exports from exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_exports_get_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :param  :
        :param  :
        :param  :
        :param  :
        :return: InlineResponse20016
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['', '', '', '', '']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method exportersexporter_id_exports_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `exportersexporter_id_exports_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['projectId'] = params['']  # noqa: E501

        query_params = []
        if '' in params:
            query_params.append(('rowsPerPage', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('page', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('sortBy', params['']))  # noqa: E501
        if '' in params:
            query_params.append(('descending', params['']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/exporters/:exporterId/exports', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse20016',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def exportersexporter_id_get(self, , **kwargs):  # noqa: E501
        """get exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_get(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :return: Definitionsexporter
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.exportersexporter_id_get_with_http_info(, **kwargs)  # noqa: E501
        else:
            (data) = self.exportersexporter_id_get_with_http_info(, **kwargs)  # noqa: E501
            return data

    def exportersexporter_id_get_with_http_info(self, , **kwargs):  # noqa: E501
        """get exporter  # noqa: E501

        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.exportersexporter_id_get_with_http_info(, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param  : (required)
        :return: Definitionsexporter
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method exportersexporter_id_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter '' is set
        if ('' not in params or
                params[''] is None):
            raise ValueError("Missing the required parameter `` when calling `exportersexporter_id_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if '' in params:
            path_params['exporterId'] = params['']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = []  # noqa: E501

        return self.api_client.call_api(
            '/exporters/:exporterId', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='Definitionsexporter',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
